//+------------------------------------------------------------------+
//|                                                     MankEAv1.mq4 |
//|                                    Scientist at ForexFactory.com |
//|                                               jim@metacoders.net |
//+------------------------------------------------------------------+
#property copyright "Scientist at ForexFactory.com"
#property link      "jim@metacoders.net"


extern int Magic=574537;

extern bool TradeHours=true; //set to false to trade continuously 

extern int StartHour=7;

extern int EndHour=18;

extern int HowManyTrades=3; //how many longs or shorts to take for each signal?

extern double Lotsize01 = 1; //1:1
extern double Lotsize02 = 0.5; //2:1
extern double Lotsize03 = 0.3; //3:1

extern bool MACross = true;


extern int SlowMAPeriod=365;
extern int SlowMAType=1; //MODE_SMA	0	Simple moving average,
                         //MODE_EMA	1	Exponential moving average,
                         //MODE_SMMA	2	Smoothed moving average,
                         //MODE_LWMA	3	Linear weighted moving average.
                         
                         
extern int FastMAPeriod=150;
extern int FastMAType=1; //MODE_SMA	0	Simple moving average,
                         //MODE_EMA	1	Exponential moving average,
                         //MODE_SMMA	2	Smoothed moving average,
                         //MODE_LWMA	3	Linear weighted moving average.
                         

extern int MA_TF=60; //timeframe for the MAs, 60 is 1 hour etc
extern bool MMMethod1=false; //the MM method in your text file
extern bool MMMethod2=true; //optial method, using Bar[1] volatility

extern bool BarOneSecondT=true; // if MMMethod2 true it will check to see if the second position should use Bar[1] volat.

extern bool BarOneThirdT=true; // if MMMethod2 true it will check to see if the third position should use Bar[1] volat.

extern int BarX=3;// the last Bar in pattern, this must be set manually

extern int StopLoss=0; //optional SL, leave at 0 for the EA to put it automatically

extern int HowManyAboveBE=0; // How many pips above/bellow BE should the SL be moved for the remaining positions?


extern bool BEPercent=true; // if true stops will be moved to BE earlier 
extern int Percent=45; // how many pips from 1st target should the stops be moved to BE?

extern int Slippage=5;


extern int SLDisplace=10; // how much lower that the lowest X Bar should the Stop Loss be

double Slow,Fast;

bool SellOp,BuyOp;

int orders,total,j;

int Bar=0;
double SL,TP,TP1,TP2,TP3;

bool Once=false;
double Store;
int dig,Slippage1,Displace1,StopLoss1,HMABE,X;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   X=BarX;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----


//do we have 5 digits?

dig=MarketInfo(Symbol(),MODE_DIGITS);

if (dig==5||dig==3) {Displace1=10*SLDisplace; Slippage1=10*Slippage; StopLoss1=StopLoss*10; HMABE=HowManyAboveBE*10;}
   else { Displace1=SLDisplace; Slippage1=Slippage; StopLoss1=StopLoss;HMABE=HowManyAboveBE;}

//count orders
orders=0;           
total = OrdersTotal();

     for(j=0;j<total;j++)
     {
      OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
  //   OrderSymbol()=symbol;
      if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol()) {
      orders++;
      
      }
      } 
      
//reset pattern with every new bar      

if(Bar<iBars(NULL,0)){

BuyOp=false;
SellOp=false;

Bar=iBars(NULL,0);
Once=false;

}

TrailingBE();

Slow=iMA(NULL,0,SlowMAPeriod,0,SlowMAType,0,1);
Fast=iMA(NULL,0,FastMAPeriod,0,FastMAType,0,1);

// Here you can set your patterns, if you dont want one just delete the whole line,its that simple

 if (High[0]<High[1]&&High[1]<High[2]&&High[2]<High[3]&&Open[0]<Open[1]&&Open[1]<Open[2]&&Open[2]<Open[3]) SellOp=true;
  
  if (High[0]>High[1]&&High[1]>High[2]&&High[2]>High[3]&&Open[0]>Open[1]&&Open[1]>Open[2]&&Open[2]>Open[3]) BuyOp=true; 
  
  
//------------------------------------------------------------------------------------

  if (MACross==true) {
  
  
 if (Fast>Slow) SellOp=false;
 
 if (Slow>Fast) BuyOp=false; 
  }
  

  
  
  if(MMMethod1==true&&BuyOp==true){ 
  Store=High[X]-Low[X];
  SL=Low[X]-Displace1*Point;
  TP1=Ask+(High[X]-Low[X]);
  TP2=Ask+2*(High[X]-Low[X]);
  TP3=Ask+3*(High[X]-Low[X]);
  }
  
  if(MMMethod2==true&&BuyOp==true){
  
  Store=High[X]-Low[X];
  SL=Low[X]-Displace1*Point;
  TP1=Ask+(High[X]-Low[X]);
  if(BarOneSecondT)  TP2=Ask+(High[1]-Low[1]);
  else TP2=Ask+2*(High[X]-Low[X]);
  if(BarOneThirdT) TP3=Ask+2*(High[1]-Low[1]);
   else TP3=Ask+3*(High[X]-Low[X]);
  }
  
  if (BuyOp==true&&Ask>Low[X]&&Once==false&&((Hour()>=StartHour&&Hour()<EndHour)||TradeHours==false)){
  
     if(StopLoss!=0) SL=Ask-StopLoss1*Point;
  
 if(HowManyTrades>0) OrderSend(Symbol(),OP_BUY,Lotsize01,Ask,Slippage1,SL,TP1,"MEA1",Magic,0,Green);
  Sleep(3000);
  
 if(HowManyTrades>1) OrderSend(Symbol(),OP_BUY,Lotsize02,Ask,Slippage1,SL,TP2,"MEA2",Magic,0,Green);
  Sleep(3000);
  
 if(HowManyTrades>2) OrderSend(Symbol(),OP_BUY,Lotsize03,Ask,Slippage1,SL,TP3,"MEA3",Magic,0,Green);
  Sleep(3000);
  Once=true;
  }
  
  if(MMMethod1==true&&SellOp==true){ 
  Store=High[X]-Low[X];
  SL=High[X]+Displace1*Point;
  TP1=Bid-(High[X]-Low[X]);
  TP2=Bid-2*(High[X]-Low[X]);
  TP3=Bid-3*(High[X]-Low[X]);
  }
  
  if(MMMethod2==true&&SellOp==true){
  
  Store=High[X]-Low[X];
  SL=High[X]+Displace1*Point;
  TP1=Bid-(High[X]-Low[X]);
  if(BarOneSecondT)  TP2=Bid-(High[1]-Low[1]);
  else TP2=Bid-2*(High[X]-Low[X]);
  if(BarOneThirdT) TP3=Bid-2*(High[1]-Low[1]);
   else TP3=Bid-2*(High[X]-Low[X]);
  }
  
  
    if (SellOp==true&& Bid<High[X]&& Once==false&&((Hour()>=StartHour&&Hour()<EndHour)||TradeHours==false)){
  
      if(StopLoss!=0) SL=Bid+StopLoss1*Point;
  
 if(HowManyTrades>0) OrderSend(Symbol(),OP_SELL,Lotsize01,Bid,Slippage1,SL,TP1,"MEA1",Magic,0,Red);
  Sleep(3000);
  
 if(HowManyTrades>1) OrderSend(Symbol(),OP_SELL,Lotsize02,Bid,Slippage1,SL,TP2,"MEA2",Magic,0,Red);
  Sleep(3000);
  
 if(HowManyTrades>2) OrderSend(Symbol(),OP_SELL,Lotsize03,Bid,Slippage1,SL,TP3,"MEA3",Magic,0,Red);
  Sleep(3000);
  Once=true;
  }
  
  
//----
   return(0);
  }
//+------------------------------------------------------------------+

void TrailingBE(){

if(MMMethod1){

  if (orders!=0) {
  
    total = OrdersTotal();

     for(j=0;j<total;j++)
     {
      OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
  //   OrderSymbol()=symbol;
      if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol()) {
      
       if(OrderType()==OP_BUY){
               
               if (((Bid>OrderOpenPrice()+Store)||(BEPercent==true&&Bid>OrderOpenPrice()+(Percent/100)*Store))&&OrderOpenPrice()>OrderStopLoss()){
                 OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+HMABE*Point,OrderTakeProfit(),0,CLR_NONE);}
                  
      
       }
       
       
       if(OrderType()==OP_SELL){
               
               if ((Ask<OrderOpenPrice()-Store||(BEPercent==true&&Ask<OrderOpenPrice()-Store*Percent/100))&&OrderOpenPrice()<OrderStopLoss()){
                 OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-HMABE*Point,OrderTakeProfit(),0,CLR_NONE);}
                  
      
       }
      
      }
      } 
      
  }
}

}      